/**
 * @name      NoFollow
 * @copyright NoFollow contributors
 * @license   BSD http://opensource.org/licenses/BSD-3-Clause
 *
 * @version 0.0.2
 *
 */

$.sceditor.plugins.bbcode.bbcode
	.set('url', {
		allowsEmpty: true,
		tags: {
			a: {
				href: null,
				rel: null
			}
		},
// 		quoteType:a.sceditor.BBCodeParser.QuoteType.never,
		quoteType: 2,
		format: function (element, content) {
			var url = element.attr('href'),
			    rels = element.attr('rel'),
			    nofollow = '';

			if (rels) {
				rels = rels.split(' ');
				for (var i = 0, t = rels.length; i < t; i++) {
					if (rels[i] == 'nofollow') {
						nofollow = ' nofollow=nofollow';
						break;
					}
				}
			}

			// make sure this link is not an e-mail,
			// if it is return e-mail BBCode
			if (url.substr(0, 7) === 'mailto:') {
				return '[email="' + url.substr(7) + '"]' +
					content + '[/email]';
			}

			if (nofollow)
			{
				return '[url url=' + url + nofollow + ']' + content + '[/url]';
			}
			else
			{
				return '[url=' + url + ']' + content + '[/url]';
			}
		},
		html: function(element, attrs, content) {
			var nofollow = '';

			if (typeof attrs.defaultattr === 'undefined' && typeof attrs.url !== 'undefined')
			{
				attrs.defaultattr = attrs.url;
			}
			attrs.defaultattr = $.sceditor.escapeEntities(attrs.defaultattr, true) || content;
			if (typeof attrs.nofollow !== 'undefined')
			{
				nofollow = ' rel="nofollow" ';
			}

			return '<a href="' + $.sceditor.escapeUriScheme(attrs.defaultattr) + '"' + nofollow + '>' + content + "</a>";
		}
	});